src/AppBundle/Form/RegistrationFormType.php
<?php

namespace AppBundle\Form;

use AppBundle\Document\Company;
use Doctrine\ODM\MongoDB\DocumentRepository;
use FOS\UserBundle\Form\Type\RegistrationFormType as BaseType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\FormBuilderInterface;

class RegistrationFormType extends BaseType
{
    /** @var DocumentRepository */
    private $companyRepository;

    /**
     * RegistrationFormType constructor.
     *
     * @param string             $class
     * @param DocumentRepository $companyRepository
     */
    public function __construct($class, DocumentRepository $companyRepository)
    {
        parent::__construct($class);
        $this->companyRepository = $companyRepository;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        parent::buildForm($builder, $options);

        $companies = [];
        /** @var Company[] $allCompanies */
        $allCompanies = $this->companyRepository->findAll();
        foreach ($allCompanies as $company) {
            $companies[$company->getName()] = $company;
        }

        $builder->add('company', ChoiceType::class, ['choices' => $companies]);
    }

    public function getName()
    {
        return 'fp_user_registration';
    }
}

src/AppBundle/Controller/DashboardController.php
<?php

namespace AppBundle\Controller;

use AppBundle\Document\Template;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Response;

class DashboardController extends Controller
{

    /**
     * @return Response
     */
    public function indexAction()
    {
        $fillings = $this->get('filling_repository')->findBy(['filler' => $this->getUser()], ['updateDate' => 'DESC']);

        return $this->render(
            'AppBundle:dashboard:index.html.twig',
            [
                'fillings' => $fillings,
            ]
        );
    }

    /**
     * @return Response
     */
    public function myTemplateAction()
    {
        $templatesEditable = $this->findTemplatesBy(['status' => Template::STATUS_EDITABLE]);

        return $this->render(
            'AppBundle:dashboard:my-template.html.twig',
            ['templatesEditable' => $templatesEditable]
        );
    }

    /**
     * @return Response
     */
    public function availableDocumentAction()
    {
        $templatesValidated = $this->findTemplatesBy(['status' => Template::STATUS_VALIDATED]);

        return $this->render(
            'AppBundle:dashboard:available-documents.html.twig',
            ['templatesValidated' => $templatesValidated]
        );
    }

    /**
     * @return Response
     */
    public function inValidationTemplateAction()
    {
        $templatesToValidate = $this->findTemplatesBy(['status' => Template::STATUS_LOCK]);

        return $this->render(
            'AppBundle:dashboard:in-validation-template.html.twig',
            ['templatesToValidate' => $templatesToValidate,]
        );
    }

    /**
     * @param array $criteria
     *
     * @return Template[]
     */
    private function findTemplatesBy(array $criteria)
    {
        if (!isset($criteria['owner'])) {
            $criteria['owner'] = $this->getUser();
        }

        return $this->get('template_repository')->findBy($criteria);
    }
}

src/AppBundle/Resources/views/dashboard/available-documents.html.twig
{% extends '@App/base.html.twig' %}

{% block body %}

    <h2>{{ 'dashboard.titles.availableDocuments'|trans }}</h2>


    <table class="table" tabindex="0">
        <thead>
        <tr>
            <th>{{ 'dashboard.title'|trans }}</th>
            <th>{{ 'dashboard.description'|trans }} / {{ 'dashboard.author'|trans }}</th>
            <th>{{ 'dashboard.creationDate'|trans }}</th>
            <th>{{ 'dashboard.version'|trans }}</th>
            <th>{{ 'dashboard.actions'|trans }}</th>
        </tr>
        </thead>
        <tbody>
        {% for template in templatesValidated %}

            <tr>
                <td>{{ template.name }}</td>
                <td>{{ template.shortDescription }}</td>
                <td>{{ template.creationDate? template.creationDate|date("d/m/Y H:i:s") : '-' }}
                    / {{ template.owner }}</td>
                <td>{{ template.version }}</td>
                <td>
                    <a class="icon-box" href="{{ path('template_restaure_edit', {templateId: template.id}) }}"
                       title="{{ 'actionHelper.restaureEditing'|trans }}"><i class="fa fa-undo"></i></a>

                    <a class="icon-box" href="{{ path('template_view', {id: template.id}) }}"
                       title="{{ 'actionHelper.view'|trans }}"
                       target="_blank"><i class="fa fa-eye"></i></a>

                    <a class="icon-box"
                       href="{{ path('template_print', {id: template.id, format: "pdf"}) }}"
                       title="{{ 'actionHelper.print'|trans }}"><i class="fa fa-file-pdf-o"></i></a>

                    <form class="create-doc-form form-inline"
                          method="post"
                          action="{{ path('filling_create', {templateId: template.id}) }}">
                        <div class="form-group">
                            <input type="text" class="form-control" name="internalRef"
                                   placeholder="{{ 'dashboard.yourInternalRef'|trans }}"/>
                            <button class="btn">{{ 'dashboard.newDocument'|trans }}</button>
                        </div>
                    </form>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="5">{{ 'dashboard.documents.emptyDocuments'|trans }}</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
{% endblock %}

src/AppBundle/Resources/views/dashboard/in-validation-template.html.twig
{% extends '@App/base.html.twig' %}

{% block body %}

    <h2>{{ 'dashboard.titles.toValidateTemplate'|trans }}</h2>


    <table class="table" tabindex="0">
        <thead>
        <tr>
            <th>{{ 'dashboard.title'|trans }}</th>
            <th>{{ 'dashboard.description'|trans }}</th>
            <th>{{ 'dashboard.creationDate'|trans }}</th>
            <th>{{ 'dashboard.actions'|trans }}</th>
        </tr>
        </thead>
        <tbody>
        {% for template in templatesToValidate %}

            <tr>
                <td>{{ template.name }}</td>
                <td>{{ template.shortDescription }}</td>
                <td>{{ template.creationDate? template.creationDate|date("d/m/Y H:i:s") : '/' }}</td>

                <td>
                    <a class="icon-box" href="{{ path('template_view', {id: template.id}) }}"
                       title="{{ 'actionHelper.view'|trans }}"
                       target="_blank"><i class="fa fa-eye"></i></a>

                    <a class="icon-box"
                       href="{{ path('template_print', {id: template.id, format: "pdf"}) }}"
                       title="{{ 'actionHelper.print'|trans }}"><i class="fa fa-file-pdf-o"></i></a>

                    <a class="icon-box confirm-it"
                       href="{{ path('template_approve', {templateId: template.id}) }}"
                       title="{{ 'actionHelper.approve'|trans }}"><i class="fa fa-check"></i></a>

                    <a class="icon-box confirm-it"
                       href="{{ path('template_reject', {templateId: template.id}) }}"
                       title="{{ 'actionHelper.reject'|trans }}"><i class="fa fa-minus-circle"></i></a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="5">{{ 'dashboard.template.nothingToValidate'|trans }}</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
{% endblock %}

{% block stylesheets %}{% endblock %}

src/AppBundle/Resources/views/dashboard/index.html.twig
{% extends '@App/base.html.twig' %}

{% block body %}

    {% if app.user %}

        <h1>{{ 'dashboard.titles.myDocuments'|trans }}</h1>

        <table class="table" tabindex="0">
            <thead>
            <tr>
                <th>{{ 'dashboard.title'|trans }}</th>
                <th>{{ 'dashboard.internalRef'|trans }}</th>
                <th>{{ 'dashboard.creationDate'|trans }} / {{ 'dashboard.author'|trans }}</th>
                <th>{{ 'dashboard.editDate'|trans }} / {{ 'dashboard.author'|trans }}</th>
                <th>{{ 'dashboard.actions'|trans }}</th>
            </tr>
            </thead>
            <tbody>
            {% for filling in fillings %}

                <tr>
                    <td>{{ filling.template.name }}</td>
                    <td>{{ filling.internalRef }}</td>
                    <td>{{ filling.creationDate|date("d/m/Y H:i:s") }} / {{ filling.filler.username }}</td>
                    <td>
                        {% if filling.updateDate != filling.creationDate %}
                            {{ filling.updateDate|date("d/m/Y H:i:s") }} / {{ filling.filler.username }}
                        {% endif %}
                    </td>
                    <td>
                        <a class="icon-box" href="{{ path('filling_edit', {fillingId: filling.id}) }}"
                           title="{{ 'actionHelper.edit'|trans }}"><i class="fa fa-edit"></i></a>
                        <a class="icon-box"
                           href="{{ path('filling_print', {fillingId: filling.id, format: "pdf"}) }}"
                           title="{{ 'actionHelper.print'|trans }}"><i class="fa fa-file-pdf-o"></i></a>

                        <a class="icon-box"
                           title="{{ 'actionHelper.exportDocX'|trans }}"
                           href="{{ path('filling_print',{fillingId: filling.id,format: "docx"}) }}">
                            <i class="fa fa-file-word-o"></i>
                        </a>

                        <a class="icon-box confirm-it"
                           title="{{ 'actionHelper.remove'|trans }}"
                           href="{{ path('filling_remove', {fillingId: filling.id}) }}"><span
                                    class="fa fa-remove"></span></a>
                    </td>
                </tr>
            {% else %}
                <tr>
                    <td colspan="5">{{ 'dashboard.documents.emptyMyDocument'|trans }}</td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
        <br/>
        <br/>
        <br/>

    {% else %}
        <p>{{ 'dashboard.pleaseLogin'|trans }}</p>
    {% endif %}
{% endblock %}

{% block stylesheets %}{% endblock %}

src/AppBundle/Resources/views/dashboard/my-template.html.twig
{% extends '@App/base.html.twig' %}

{% block body %}
    <h2>{{ 'dashboard.titles.editableTemplate'|trans }}</h2>

    <table class="table" tabindex="0">
        <thead>
        <tr>
            <th>{{ 'dashboard.title'|trans }}</th>
            <th>{{ 'dashboard.description'|trans }}</th>
            <th>{{ 'dashboard.creationDate'|trans }}</th>
            <th>{{ 'dashboard.actions'|trans }}</th>
        </tr>
        </thead>
        <tbody>
        {% for template in templatesEditable %}

            <tr>
                <td>{{ template.name }}</td>
                <td>{{ template.shortDescription }}</td>
                <td>{{ template.creationDate? template.creationDate|date("d/m/Y H:i:s") : '/' }}</td>
                <td>
                    <a class="icon-box" href="{{ path('template_edit', {id: template.id}) }}"
                       title="{{ 'actionHelper.edit'|trans }}"><i class="fa fa-edit"></i></a>

                    <a class="icon-box" href="{{ path('template_view', {id: template.id}) }}"
                       title="{{ 'actionHelper.view'|trans }}"
                       target="_blank"><i class="fa fa-eye"></i></a>

                    <a class="icon-box"
                       href="{{ path('template_print', {id: template.id, format: "pdf"}) }}"
                       title="{{ 'actionHelper.print'|trans }}"><i class="fa fa-file-pdf-o"></i></a>

                    <a class="icon-box confirm-it" href="{{ path('template_remove', {id: template.id}) }}"
                       title="{{ 'actionHelper.remove'|trans }}"><i class="fa fa-remove"></i></a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="5">{{ 'dashboard.template.emptyMyTemplate'|trans }}</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
{% endblock %}

{% block stylesheets %}{% endblock %}